﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved

var ColorSelector = {
    lastSymbolUsed: 190,
    isSymbolDialogDisplayed: false,

    colors: [{ "color": "#000000", "symbol": "&#33" },
              { "color": "#7f7f7f", "symbol": "&#34" },
              { "color": "#880015", "symbol": "&#35" },
              { "color": "#ED1C24", "symbol": "&#36" },
              { "color": "#ff7f27", "symbol": "&#37" },
              { "color": "#FFF200", "symbol": "&#38" },
              { "color": "#22B14C", "symbol": "&#39" },
              { "color": "#00A2E8", "symbol": "&#40" },
              { "color": "#3F48CC", "symbol": "&#41" },
              { "color": "#A349A4", "symbol": "&#42" },
              { "color": "#FFFFFF", "symbol": "&#50" },
              { "color": "#C3C3C3", "symbol": "&#43" },
              { "color": "#B97A57", "symbol": "&#44" },
              { "color": "#ffaec9", "symbol": "&#45" },
              { "color": "#FFC90E", "symbol": "&#46" },
              { "color": "#EFE4B0", "symbol": "&#47" },
              { "color": "#B5E61D", "symbol": "&#48" },
              { "color": "#99D9EA", "symbol": "&#49" },
              { "color": "#7092BE", "symbol": "&#51" },
              { "color": "#C8BFE7", "symbol": "&#52" },

              { "color": "#CD5C5C", "symbol": "&#53" }, // indianred
              {"color": "#F08080", "symbol": "&#54" }, // lightcoral
              {"color": "#FA8072", "symbol": "&#55" }, // salmon
              {"color": "#E9967A", "symbol": "&#56" }, // darksalmon
              {"color": "#FFA07A", "symbol": "&#57" }, // lightsalmon
              {"color": "#DC143C", "symbol": "&#58" }, // crimson
              {"color": "#B22222", "symbol": "&#59" }, // firebrick
              {"color": "#8B0000", "symbol": "&#60" }, // darkred


              {"color": "#FFC0CB", "symbol": "&#61" }, // pink
              {"color": "#FFB6C1", "symbol": "&#62" }, // lightpink
              {"color": "#FF69B4", "symbol": "&#63" }, // hotpink
              {"color": "#FF1493", "symbol": "&#64" }, // deeppink
              {"color": "#C71585", "symbol": "&#65" }, // mediumvioletred
              {"color": "#DB7093", "symbol": "&#66" }, // palevioletred

              {"color": "#FF7F50", "symbol": "&#68" }, // CORAL
              {"color": "#FF6347", "symbol": "&#69" }, // TOMATO
              {"color": "#FF4500", "symbol": "&#70" }, // ORANGERED
              {"color": "#FF8C00", "symbol": "&#71" }, // DARKORANGE
              {"color": "#FFA500", "symbol": "&#72" }, // ORANGE


              {"color": "#FFD700", "symbol": "&#73" }, // GOLD
              {"color": "#FFFF00", "symbol": "&#74" }, // YELLOW
              {"color": "#FFFFE0", "symbol": "&#75" }, // LIGHTYELLOW
              {"color": "#FFFACD", "symbol": "&#76" }, // LEMONCHIFFON
              {"color": "#FAFAD2", "symbol": "&#77" }, // LIGHTGOLDENRODYELLOW

              {"color": "#FFE4B5", "symbol": "&#78" }, // MOCCASIN
              {"color": "#FFDAB9", "symbol": "&#79" }, // PEACHPUFF


              {"color": "#EEE8AA", "symbol": "&#80" }, // PALEGOLDENROD
              {"color": "#F0E68C", "symbol": "&#81" }, // KHAKI
              {"color": "#BDB76B", "symbol": "&#82" }, // DARKKHAKI

              {"color": "#E6E6FA", "symbol": "&#83" }, // LAVENDER
              {"color": "#D8BFD8", "symbol": "&#84" }, // THISTLE
              {"color": "#DDA0DD", "symbol": "&#85" }, // PLUM
              {"color": "#EE82EE", "symbol": "&#86" }, // VIOLET
              {"color": "#DA70D6", "symbol": "&#87" }, // ORCHID
              {"color": "#FF00FF", "symbol": "&#88" }, // FUCHSIA             
              {"color": "#9370DB", "symbol": "&#90" }, // MEDIUMPURPLE
              {"color": "#663399", "symbol": "&#91" }, // REBECCAPURPLE
              {"color": "#8A2BE2", "symbol": "&#92" }, // BLUEVIOLET
              {"color": "#9400D3", "symbol": "&#93" }, // DARKVIOLET
              {"color": "#8B008B", "symbol": "&#94" }, // DARKORCHID
              {"color": "#800080", "symbol": "&#95" }, // PURPLE
              {"color": "#4B0082", "symbol": "&#96" }, // INDIGO
              {"color": "#6A5ACD", "symbol": "&#97" }, // SLATEBLUE
              {"color": "#483D8B", "symbol": "&#98" }, // DARKSLATEBLUE
              {"color": "#7B68EE", "symbol": "&#99" }, // MEDIUMSLATEBLUE

              {"color": "#ADFF2F", "symbol": "&#100" }, // GREENYELLOW
              {"color": "#7FFF00", "symbol": "&#101" }, // CHARTREUSE
              {"color": "#7CFC00", "symbol": "&#102" }, // LAWNGREEN
              {"color": "#00FF00", "symbol": "&#103" }, // LIME
              {"color": "#32CD32", "symbol": "&#104" }, // LIMEGREEN
              {"color": "#98FB98", "symbol": "&#105" }, // PALEGREEN
              {"color": "#90EE90", "symbol": "&#106" }, // LIGHTGREEN
              {"color": "#00FA9A", "symbol": "&#107" }, // MEDIUMSPRINGGREEN
              {"color": "#00FF7F", "symbol": "&#108" }, // SPRINGGREEN
              {"color": "#3CB371", "symbol": "&#109" }, // MEDIUMSEAGREEN
              {"color": "#2E8B57", "symbol": "&#110" }, // SEAGREEN
              {"color": "#228B22", "symbol": "&#111" }, // FORESTGREEN
              {"color": "#008000", "symbol": "&#112" }, // GREEN
              {"color": "#006400", "symbol": "&#113" }, // DARKGREEN
              {"color": "#9ACD32", "symbol": "&#114" }, // YELLOWGREEN
              {"color": "#6B8E23", "symbol": "&#115" }, // OLIVEDRAB
              {"color": "#808000", "symbol": "&#116" }, // OLIVE
              {"color": "#556B2F", "symbol": "&#117" }, // DARKOLIVEGREEN
              {"color": "#66CDAA", "symbol": "&#118" }, // MEDIUMAQUAMARINE
              {"color": "#8FBC8B", "symbol": "&#119" }, // DARKSEAGREEN

              {"color": "#008B8B", "symbol": "&#121" }, // DARKCYAN

              {"color": "#008080", "symbol": "&#122" }, // TEAL
              {"color": "#00FFFF", "symbol": "&#123" }, // AQUA
              {"color": "#E0FFFF", "symbol": "&#124" }, // LIGHTCYAN
              {"color": "#AFEEEE", "symbol": "&#125" }, // PALETURQUOISE
              {"color": "#7FFFD4", "symbol": "&#126" }, // AQUAMARINE 

              {"color": "#40E0D0", "symbol": "&#172" }, // TURQUOISE   

              {"color": "#48D1CC", "symbol": "&#194" }, // MEDIUMTURQUOISE 

              {"color": "#00CED1", "symbol": "&#174" }, // DARKTURQUOISE 
              {"color": "#5F9EA0", "symbol": "&#175" }, // CADETBLUE    
              {"color": "#4682B4", "symbol": "&#176" }, // STEELBLUE     
              {"color": "#B0C4DE", "symbol": "&#177" }, // LIGHTSTEELBLUE   
              {"color": "#B0E0E6", "symbol": "&#178" }, // POWDERBLUE 
              {"color": "#ADD8E6", "symbol": "&#179" }, // LIGHTBLUE 
              {"color": "#87CEEB", "symbol": "&#180" }, // SKYBLUE      


              {"color": "#87CEFA", "symbol": "&#181" }, // LIGHTSKYBLUE  
              {"color": "#00BFFF", "symbol": "&#182" }, // DEEPSKYBLUE 
              {"color": "#1E90FF", "symbol": "&#183" }, // DODGERBLUE  
              {"color": "#6495ED", "symbol": "&#184" }, // CORNFLOWERBLUE 

              {"color": "#4169E1", "symbol": "&#185" }, // ROYALBLUE 
              {"color": "#0000FF", "symbol": "&#186" }, // BLUE  
              {"color": "#0000CD", "symbol": "&#187" }, // MEDIUMBLUE  
              {"color": "#00008B", "symbol": "&#188" }, // DARKBLUE 
              {"color": "#000080", "symbol": "&#189" }, // NAVY  
              {"color": "#191970", "symbol": "&#190" }, // MIDNIGHTBLUE  

              {"color": "#D2B48C", "symbol": "&#120" }, // TAN  
              {"color": "#BC8F8F", "symbol": "&#89" }, // ROSYBROWN 
              {"color": "#F4A460", "symbol": "&#67" }, // SANDYBROWN 
              {"color": "#DAA520", "symbol": "&#160" }, // GOLDENROD  f
              {"color": "#B8860B", "symbol": "&#161" }, // DARKGOLDENROD  sqaure on edge
              {"color": "#CD853F", "symbol": "&#162" }, // PERU  dimaond 
              {"color": "#D2691E", "symbol": "&#163" }, // CHOCOLATE bow tie
              {"color": "#8B4513", "symbol": "&#165" }, // SADDLEBROWN double triangles on side
              {"color": "#A0522D", "symbol": "&#167" }, // SIENNA down arrow
              {"color": "#A52A2A", "symbol": "&#168" }, // BROWN diamond 
              {"color": "#800000", "symbol": "&#169" }, // MAROON 6

              {"color": "#708090", "symbol": "&#170" }, // LIGHTSLATEGRAY  flower
              {"color": "#2F4F4F", "symbol": "&#171"}], // DARKSLATEGRAY cross


    isDisplayed: false,
    totalBtns: 0,
    currentSelectedButtonId: "",
    drawColor: "#000000",
    colorPicker: [],
    mouse: {},

    openNav: function () {
        document.getElementById("colorBtnSideNav").style.width = "17em";
        document.getElementById("colorSideNav").style.width = "4.3em";
    },

    closeNav: function () {
        document.getElementById("colorBtnSideNav").style.width = "0";
        document.getElementById("colorSideNav").style.width = "0";
    },

    createColorSelector: function () {
        //    <div id='colorStaticBtnDiv'>

        //<table id=staticColorBtnTable>
        //  <tr id='staticColorBtnTr_" + i.toString() >
        //    <td>
        //       <div id='staticColorBtnDiv_" + i.toString()   data-color="#77777" symbol="50"
        //          <canvas id=staticColorBtn_" + i.toString()></canvas>
        //      </div>
        //    </td>
        //    <td>
        //        <div>
        //            symbol
        //        </div
        //        <div>
        //            count
        //        </div>
        //    </td>
        //  </tr>
        //</table>
        //    ...
        //</div>
        // create the predefined color buttons
        var blackSymbol = ColorSelector.colors[0].symbol;
        var colorStaticBtnDiv = $("#colorStaticBtnDiv");
        for (var i = 0; i < ColorSelector.colors.length; i++) {
            var btnTable = $(
            "<table id='staticColorBtnTable_" + i.toString() + "' style='border-width:2px;border-color:transparent;border-style:solid'  onclick='ColorSelector.setCurrentSelectedButton(this)'>" +
                "<tr id='staticColorBtnTr_" + i.toString() + "'>" +
                    "<td>" +
                         "<div id='staticColorBtnDiv_" + i.toString() + "' data-color='" + ColorSelector.colors[i].color + "'>" +
                              "<canvas id='staticColorBtn_" + i.toString() + "' width='22px' height='32px'</canvas></div>" +
                "</td></tr></table>");

            // canvas id, symbol
            colorStaticBtnDiv.append(btnTable);
            ColorSelector.addButtonSymbol("staticColorBtn_" + i.toString(), ColorSelector.colors[i].symbol);

        }
        var colorPaletteDiv = $("#colorPaletteDiv");

        ColorSelector.enableModifyButtons(false, false);
        ColorSelector.populateColorSymbolDialog();
    },

    setButtonSymbol: function (canvasId, symbol) {
        var symbolDivId = canvasId + "_symbol";
        var symbolDiv = $("#" + symbolDivId);
        symbolDiv.html(symbol);
        var colorBtnDivId = canvasId.replace("Btn_", "BtnDiv_");
        var symbolDiv = $("#" + colorBtnDivId);
        var symText = symbol.replace("&#", "");
        symbolDiv.data("symbol", symText);
    },

    addButtonSymbol: function (canvasId, symbol) {
        var countDivId = canvasId + "_count";
        var symbolDivId = canvasId + "_symbol";
        var countDiv = $("#" + countDivId);
        var count = countDiv.length > 0 ? countDiv.text() : 0;

        var colorBtnTrId = canvasId.replace("Btn_", "BtnTr_");
        var colorBtnTr = $("#" + colorBtnTrId);

        colorBtnTr.append("<td><div id='" + symbolDivId + "' style='font-family:crochetdesignsfont;font-size:15px;'>" + symbol + "</div>" +
                       "<div id='" + countDivId + "' style='font-family:arial;font-size:.7em'>" + count + "</div></td>");

        var colorBtnDivId = canvasId.replace("Btn_", "BtnDiv_");
        var colorBtnDiv = $("#" + colorBtnDivId);
        colorBtnDiv.data("symbol", symbol.replace("&#", ""));
        ColorSelector.setButtonColor(canvasId);
    },

    // draw the bead
    setButtonColor: function (canvasId) {
        var rectX = 0;
        var rectY = 0;
        var rectWidth = 20;
        var rectHeight = 30;
        var cornerRadius = 5;
        var lineWidth = 1;
        var colorBtnDivId = canvasId.replace("Btn_", "BtnDiv_");
        var colorBtnDiv = $("#" + colorBtnDivId);
        var bgColor = colorBtnDiv.data("color");
        var bgHex = bgColor[0] === "#" ? bgColor.toLowerCase() : ColorConvert.rgbToHex(bgColor).toLowerCase();
        var fgColor = ColorConvert.hexIsLight(bgHex) ? '#000' : '#FFF';
        var canvas = $("#" + canvasId);
        var ctx = canvas[0].getContext("2d");
        Bead.drawBead(ctx, rectX, rectY, rectWidth, rectHeight, bgHex, cornerRadius, lineWidth, true, true);
    },

    addUserDefColors: function () {

        //create the user defined color buttons
        if (_pat !== undefined) {
            var userDefColors = _pat.getUserDefColors();

            $.each(userDefColors, function (index, value) {
                // if color button already exists for this color then skip it
                var existingColor = ColorSelector.getExistingColorBtn(value.color, null);

                if (existingColor === "") {
                    ColorSelector.lastSymbolUsed += 1;
                    var btn = ColorSelector.addColorButton(value.color, "&#" + value.symbol, false, true);
                    btn.data("usedcolor", "yes");
                }
            });
        }
    },

    // remove all the user defined color buttons
    removeUserDefColors: function () {
        for (var i = 0; i < ColorSelector.totalBtns; i++) {
            var colorBtnTable = $("#colorBtnTable_" + i);
            colorBtnTable.remove();
        }
        ColorSelector.totalBtns = 0;
    },


    populateColorSymbolDialog: function () {


        var sym = 33; // first symbol is box outline
        var grid = $("#colorSymbolGrid");
        for (var i = 0; i < 60; i = i + 5) {

            var col1 = $("<div class='ui-block-a'><button id='symbol_" + (i + 1).toString() + "' style='margin:0;font-family:crochetdesignsfont;font-size:15px;' data-symbol='&#" + (sym + i).toString() + "' class='ui-btn ui-corner-all  ui-btn-c' onclick='ColorSelector.symbolButtonClick(\"symbol_" + (i + 1).toString() + "\");'>" + String.fromCharCode(sym + i) + "</button></div>");
            var col2 = $("<div class='ui-block-b'><button id='symbol_" + (i + 2).toString() + "' style='margin:0;font-family:crochetdesignsfont;font-size:15px;' data-symbol='&#" + (sym + i + 1).toString() + "' class='ui-btn ui-corner-all  ui-btn-c' onclick='ColorSelector.symbolButtonClick(\"symbol_" + (i + 2).toString() + "\");'>" + String.fromCharCode(sym + i + 1) + "</button></div>");
            var col3 = $("<div class='ui-block-c'><button id='symbol_" + (i + 3).toString() + "' style='margin:0;font-family:crochetdesignsfont;font-size:15px;' data-symbol='&#" + (sym + i + 2).toString() + "' class='ui-btn ui-corner-all ui-btn-c' onclick='ColorSelector.symbolButtonClick(\"symbol_" + (i + 3).toString() + "\");'>" + String.fromCharCode(sym + i + 2) + "</button></div>");
            var col4 = $("<div class='ui-block-d'><button id='symbol_" + (i + 4).toString() + "' style='margin:0;font-family:crochetdesignsfont;font-size:15px;' data-symbol='&#" + (sym + i + 3).toString() + "' class='ui-btn ui-corner-all  ui-btn-c' onclick='ColorSelector.symbolButtonClick(\"symbol_" + (i + 4).toString() + "\");'>" + String.fromCharCode(sym + i + 3) + "</button></div>");
            var col5 = $("<div class='ui-block-e'><button id='symbol_" + (i + 5).toString() + "' style='margin:0;font-family:crochetdesignsfont;font-size:15px;' data-symbol='&#" + (sym + i + 4).toString() + "' class='ui-btn ui-corner-all  ui-btn-c' onclick='ColorSelector.symbolButtonClick(\"symbol_" + (i + 5).toString() + "\");'>" + String.fromCharCode(sym + i + 4) + "</button></div>");

            grid.append(col1);
            grid.append(col2);
            grid.append(col3);
            grid.append(col4);
            grid.append(col5);
        }
    },
    displaySymbolDialog: function (display) {
        var dlg = $("#colorSymbolDiv");
        if (display) {
            dlg.popup("open");
            ColorSelector.isSymbolDialogDisplayed = true;
        }
        else {
            app.currentPage = "symbol-page";
            dlg.popup("close");
            ColorSelector.isSymbolDialogDisplayed = false;
        }
    },

    addNewColorButton: function () {
        var colorButton = $("#color");
        var bgColor = colorButton.css("background-color");
        var existingColor = ColorSelector.getExistingColorBtn(bgColor, null);

        // need to add a new color button
        if (existingColor === "") {
            ColorSelector.lastSymbolUsed += 1;
            var btn = ColorSelector.addColorButton(bgColor, "&#" + ColorSelector.lastSymbolUsed, false, true);
            btn.data("usedcolor", "yes");
            ColorSelector.enableModifyButtons(true, false);
        }

        // else if user defined color button already exists for this color
        else {
            var isUserDefColorBtn = ColorSelector.currentSelectedButtonId.indexOf("colorBtn_") >= 0;
            if (isUserDefColorBtn) {
                var btn = $("#" + ColorSelector.currentSelectedButtonId);
                if (btn.length === 0) {
                    ColorSelector.enableModifyButtons(false, true);
                }
                else {
                    var colorBtnDivId = ColorSelector.currentSelectedButtonId.replace("Btn_", "BtnDiv_");
                    var colorBtnDiv = $("#" + colorBtnDivId);
                    colorBtnDiv.data("usedcolor", "yes");
                    ColorSelector.enableModifyButtons(true, true);
                }
            }

            // else static or palette button
            else {
                ColorSelector.enableModifyButtons(false, false);
            }
        }
    },
    addColorButton: function (bgColor, symText, show, space) {

        var colorSideNav = $("#colorSideNav");
        colorSideNav.scrollTop(0);

        var symHex = (symText.substring(0, 2) === "&#") ? symText.substring(2, symText.length) : symText.charCodeAt(0);
        var colorBtnDiv = $("#colorBtnDiv");
        var margin = space ? "margin-left:2px;" : "";
        

        var btnTable = $("<table id='colorBtnTable_" + ColorSelector.totalBtns + "' style='border-width:2px;border-color:transparent;border-style:solid' onclick='ColorSelector.setCurrentSelectedButton(this)'>" +
                             "<tr id='colorBtnTr_" + ColorSelector.totalBtns + "'>" +
                                 "<td>" +
                                       "<div id='colorBtnDiv_" + ColorSelector.totalBtns + "' data-color='#ffffff'>" +
                                             "<canvas id='colorBtn_" + ColorSelector.totalBtns + "' width='22px' height='32px'></canvas></div>" +
                "</td></tr></table>");
        colorBtnDiv.append(btnTable);
        colorBtnDivItemId = "colorBtnDiv_" + ColorSelector.totalBtns;
        var colorBtnDivItem = $("#" + colorBtnDivItemId);

        ColorSelector.colorPicker[ColorSelector.totalBtns] = new jscolor(colorBtnDivItem[0], { clickToShow: false, closable: true, closeText: 'Close', cancelable: false, cancelText: 'Close', deleteable: false, deleteText: 'Delete', valueElement: null, value: bgColor });
        ColorSelector.addButtonSymbol("colorBtn_" + ColorSelector.totalBtns, "&#" + symHex);

        if (show) {
            ColorSelector.colorPicker[ColorSelector.totalBtns].show();
        }
        ColorSelector.totalBtns++;
        return colorBtnDiv;
    },

    addColorButtonsOnPattern: function () {
        if (_pat !== null) {
            var colorCnts = _pat.getAllColorCounts();
            $.each(colorCnts, function (color, value) {
                if (color.toLowerCase() !== "#zzzzzz") {
                    // if color button already exists for this color then skip it
                    var existingColor = ColorSelector.getExistingColorBtn(color, null);
                    if (existingColor === "") {
                        ColorSelector.lastSymbolUsed += 1;
                        var btn = ColorSelector.addColorButton(color, "&#" + ColorSelector.lastSymbolUsed, false, true);
                        btn.data("usedcolor", "yes");
                    }
                }
            });
        }
    },

    modifyColorButton: function () {
        if (ColorSelector.currentSelectedButtonId !== "") {
            var i = ColorSelector.currentSelectedButtonId.substring(ColorSelector.currentSelectedButtonId.indexOf("_") + 1);
            ColorSelector.colorPicker[i].show();
        }
    },
    deleteColorButton: function () {
        if (ColorSelector.currentSelectedButtonId !== "") {
            var colorButton = $("#color");
            var btnColor = colorButton.css("background-color");
            var btnHexColor = ColorConvert.rgbToHex(btnColor);

            var isUserDefColorBtn = ColorSelector.currentSelectedButtonId.indexOf("colorBtn_") >= 0;
            if (isUserDefColorBtn) {
                var colorBtnTableId = ColorSelector.currentSelectedButtonId.replace("Btn_", "BtnTable_");
                var colorBtnTable = $("#" + colorBtnTableId);
                colorBtnTable.hide();
                var color = $("#W" + ColorSelector.currentSelectedButtonId).data("color");
                var hexColor = ColorConvert.rgbToHex(color);

                if (hexColor === btnHexColor) {
                    colorButton.css("background-color", ColorSelector.colors[0].color);

                    ColorSelector.setCurrentSelectedButton("#staticColorBtnTable_0");
                    _pat.setfilledSqrColor(ColorSelector.colors[0].color);
                }
            }
            ColorSelector.enableModifyButtons(false, false);
        }
    },

    modifySymbolButton: function () {
        ColorSelector.displaySymbolDialog(true);
    },

    setCurrentSelectedButton: function (btn) {
        var btnTable = $(btn);
        var btnTableId = btnTable.attr("id");
        var selectedBtnDivId = btnTableId.replace("BtnTable_", "BtnDiv_").replace("ColorBtn_", "ColorBtnDiv_");
        var selectedBtnDiv = $("#" + selectedBtnDivId);
        var symText = selectedBtnDiv.data("symbol");

        // change last selected color border back to gray
        if (ColorSelector.currentSelectedButtonId !== "") {
            var tableId = ColorSelector.currentSelectedButtonId.replace("Btn_", "BtnTable_");
            var table = $("#" + tableId);
            table.css("border-color", "transparent");
        }

        // highlight just selected color button
        if (selectedBtnDivId !== null && selectedBtnDivId !== undefined && selectedBtnDivId !== "") {
            var colorUsed = selectedBtnDiv.data("usedcolor") === "yes";
            var isStaticColorBtn = selectedBtnDivId.indexOf("static") >= 0;
            var isPaletteColorBtn = selectedBtnDivId.indexOf("palette") >= 0;

            ColorSelector.enableModifyButtons(!isStaticColorBtn && !isPaletteColorBtn, colorUsed);
            btnTable.css("border-color", "#4444FF");

            // set the drawing color button background color and symbol
            var color = selectedBtnDiv.data("color");

            ColorSelector.drawColor = color;
            if (_pat !== undefined) {
                _pat.setfilledSqrColor(color);
            }
            $("#color").css("background-color", color);
        }
        else {
            ColorSelector.enableModifyButtons(false, false);
        }
        var selectedBtnId = btnTableId.replace("BtnTable_", "Btn_");
        ColorSelector.currentSelectedButtonId = selectedBtnId;
    },

    enableModifyButtons: function (enable, colorUsed) {
        if (enable) {
            if (!colorUsed) {
                $("#deleteColorButton").removeAttr("disabled");
                $("#modifyColorButton").removeAttr("disabled");
            }
            else {
                $("#modifyColorButton").attr('disabled', 'disabled');
                $("#deleteColorButton").attr('disabled', 'disabled');
            }

            $("#modifySymbolButton").removeAttr("disabled");
        }
        else {
            $("#modifyColorButton").attr('disabled', 'disabled');
            $("#deleteColorButton").attr('disabled', 'disabled');
            $("#modifySymbolButton").attr('disabled', 'disabled');
        }
    },
    symbolButtonClick: function (sym) {
        var symbolBtn = $("#" + sym);
        var symtext = parseInt(sym.replace("symbol_", ""), 10) + 32;
        var symtext = "&#" + symtext.toString();
        ColorSelector.setButtonSymbol(ColorSelector.currentSelectedButtonId, symtext);
        ColorSelector.displaySymbolDialog(false);
        if (_pat !== undefined && _pat !== null) {
            if (_pat.getDisplaySymbols()) {
                _pat.drawSquares();
            }
        }
    },
    displaySymbolsOnPattern: function (display) {
        if (_pat !== undefined && _pat !== null) {
            _pat.setDisplaySymbols(display);
            _pat.drawSquares();

        }
    },
    touchStart: function (event) {

        // if user touched with one finger
        if (event.originalEvent.touches.length >= 1) {
            ColorSelector.mouse = {
                'touches': 1,
                'startX1': event.originalEvent.touches[0].pageX,
                'endX1': -1,
                'startY1': event.originalEvent.touches[0].pageY,
                'endY1': -1
            };
        }
    },
    touchMove: function (event) {
        // use touched in header/tab space
        if (ColorSelector.mouse.startY1 === undefined || ColorSelector.mouse.startX1 === undefined)
            return;

        // if user touched with one finger and moving it
        if (event.originalEvent.touches.length === 1) {

            ColorSelector.mouse.endX1 = event.originalEvent.touches[0].pageX;
            ColorSelector.mouse.endY1 = event.originalEvent.touches[0].pageY;

            // get x and y deltas
            var deltaX = ColorSelector.mouse.endX1 - ColorSelector.mouse.startX1;
            var deltaY = ColorSelector.mouse.endY1 - ColorSelector.mouse.startY1;

            // move the pattern by delta x and y only if x or y changed by at least 3 pixels
            var colorSelectorDiv = $("#colorSelectorDiv");
            var offset = colorSelectorDiv.offset();
            if (Math.abs(deltaX) > 2 || Math.abs(deltaY) > 2) {
                try {
                    if (colorSelectorDiv !== undefined && colorSelectorDiv.length !== undefined && colorSelectorDiv.length > 0) {
                        var newTop = deltaY + offset.top;
                        var newLeft = deltaX + offset.left;
                        colorSelectorDiv.offset({ top: newTop, left: newLeft });
                    }
                }
                catch (err) {
                }
                ColorSelector.mouse.startX1 = ColorSelector.mouse.endX1;
                ColorSelector.mouse.startY1 = ColorSelector.mouse.endY1;
            }
        }
    },
    touchEnd: function () {
        // use touched in header/tab space
        if (ColorSelector.mouse.startY1 === undefined || ColorSelector.mouse.startX1 === undefined)
            return;
        ColorSelector.mouse = {};
    },

    // moving mouse on color selector
    setBtnColorFromPicker: function (colorBtnD, hexColor) {
        var colorBtnDiv = $(colorBtnD);
        var colorBtnDivId = colorBtnDiv.attr("id");
        var canvasId = colorBtnDivId.replace("BtnDiv_", "Btn_");
        colorBtnDiv.data("color", hexColor);
        ColorSelector.setButtonColor(canvasId);
    },

    // mouse up on color selector
    setSymbolFromPicker: function (btnDiv) {
        var colorBtnDiv = $(btnDiv);
        var colorBtnDivId = colorBtnDiv.attr("id");
        var color = colorBtnDiv.data("color");
        var colorTableId = colorBtnDivId.replace("BtnDiv_", "BtnTable_");
        ColorSelector.setCurrentSelectedButton("#" + colorTableId);
        var existingColorSymbol = ColorSelector.getExistingColorSymbol(color, colorBtnDiv);
        if (existingColorSymbol !== "") {
            var canvasId = colorBtnDivId.replace("BtnDiv_", "Btn_");
            ColorSelector.setButtonSymbol(canvasId, "&#" + existingColorSymbol);
        }
        else {
            var symbol = colorBtnDiv.data("symbol");
            // white symbol             
            if (symbol === "50") {
                ColorSelector.lastSymbolUsed += 1;
                var symText = ColorSelector.lastSymbolUsed.toString();
                var colorBtnId = colorBtnDivId.replace("BtnDiv_", "Btn_");
                ColorSelector.setButtonSymbol(colorBtnId, "&#" + symText);
            }
        }
    },

    setSymbol: function (btn) {
        var colorBtn = $(btn);
        var colorBtnId = colorBtn.attr("id");
        var colorBtnDivId = colorBtnId.replace("Btn_", "BtnDiv_");
        var colorBtnTableId = colorBtnId.replace("Btn_", "BtnTable_");

        var bgColor = colorBtn.css("background-color");
        var existingColorSymbol = ColorSelector.getExistingColorSymbol(bgColor, colorBtn);

        if (existingColorSymbol !== "") {
            var symbol = colorBtn.data("symbol");
            colorBtn.html("<div style='position:absolute;top:1px;left:8px'>&#" + existingColorSymbol + "</div>");
            var c = parseInt(existingColorSymbol, 10);
            colorBtn.data("symbol", c.toString());
        }
        else {
            var symbol = colorBtn.data("symbol");
            // white symbol             
            if (symbol === "50") {
                ColorSelector.lastSymbolUsed++;
                var symText = ColorSelector.lastSymbolUsed.toString();
                ColorSelector.setButtonSymbol(colorBtnId, "&#" + symText);
            }
            else {
                var color = $("#color");
                var hexColor = ColorConvert.rgbToHex(bgColor);
                ColorSelector.drawColor = hexColor;
                _pat.setfilledSqrColor(hexColor);
                color.css("background-color", hexColor);
            }
            ColorSelector.setCurrentSelectedButton("#" + colorBtnTableId);
        }
        ColorSelector.scrollToBottom();
    },

    getExistingColorBtnId: function (color) {
        var colorHex = color[0] === "#" ? color.toLowerCase() : ColorConvert.rgbToHex(color).toLowerCase();

        // search static colors
        for (var i = 0; i < ColorSelector.colors.length; i++) {
            if (ColorSelector.colors[i].color.toLowerCase() === colorHex) {
                return "staticColorBtn_" + i.toString();
            }
        }

        // search user created buttons
        for (var i = 0; i < ColorSelector.totalBtns; i++) {
            var btnDiv = $("#colorBtnDiv_" + i.toString());
            var bgColor = btnDiv.data("color");
            var btnColorHex = bgColor[0] === "#" ? bgColor.toLowerCase() : ColorConvert.rgbToHex(bgColor).toLowerCase();
            if (btnColorHex === colorHex) {
                return "#colorBtn_" + i.toString();
            }
        }
    },

    getExistingColorBtn: function (color, colorBtnDiv) {
        var colorHex = color[0] === "#" ? color.toLowerCase() : ColorConvert.rgbToHex(color).toLowerCase();
        // search static colors
        for (var i = 0; i < ColorSelector.colors.length; i++) {
            if (ColorSelector.colors[i].color.toLowerCase() === colorHex) {
                return ColorSelector.colors[i].color;
            }
        }

        // search user created buttons
        for (var i = 0; i < ColorSelector.totalBtns; i++) {
            var btn = $("#colorBtnDiv_" + i.toString());
            var bgColor = btn.data("color");
            var btnColorHex = bgColor[0] === "#" ? bgColor.toLowerCase() : ColorConvert.rgbToHex(bgColor).toLowerCase();
            if (btnColorHex === colorHex) {
                if (colorBtnDiv === null) {
                    return btnColorHex;
                }
                else {
                    var colorBtnDivId = colorBtnDiv.attr("id");
                    if ("colorBtnDiv_" + i !== colorBtnDivId) {
                        return btnColorHex;
                    }
                }
            }
        }       
        return "";
    },

    getExistingColorSymbol: function (color, thisBtn) {
        var colorHex = color[0] === "#" ? color.toLowerCase() : ColorConvert.rgbToHex(color).toLowerCase();
        for (var i = 0; i < ColorSelector.colors.length; i++) {
            if (ColorSelector.colors[i].color.toLowerCase() === colorHex) {
                return ColorSelector.colors[i].symbol.replace("&#", "");
            }
        }
       
        for (var i = 0; i < ColorSelector.totalBtns; i++) {
            var btnDiv = $("#colorBtnDiv_" + i.toString());
            var colorValue = btnDiv.data("color");
            var btnColorHex = colorValue[0] === "#" ? colorValue.toLowerCase() : ColorConvert.rgbToHex(colorValue).toLowerCase();
            if (btnColorHex === colorHex) {
                if (thisBtn === undefined || (thisBtn.attr("id") !== btnDiv.attr("id"))) {
                    var hex = btnDiv.data("symbol").toString();
                    return hex.replace("&#", "");
                }
            }
        }
        return "";
    },
    getPaletteFileContents: function () {

        var contents = "<colorpalette>";
        for (var i = 0; i < ColorSelector.totalBtns; i++) {
            var btn = $("#colorBtn_" + i.toString());
            var bgColor = btn.css("background-color");
            var btnColorHex = bgColor[0] === "#" ? bgColor.toLowerCase() : ColorConvert.rgbToHex(bgColor).toLowerCase();
            var symbolHex = btn.data("symbol").toString();
            contents += "<colorbutton color='" + btnColorHex + "' symbol='" + symbolHex + " />";
        }
        contents += "</colorpalette>";
        return contents;
    },
    updateColorCount: function () {
        var bigButton = $("#color");
        var bgColor = bigButton.css("background-color");
        var hexColor = bgColor[0] === "#" ? bgColor.toLowerCase() : ColorConvert.rgbToHex(bgColor).toLowerCase();
        var cnt = _pat.getColorCount(hexColor);
        var countDiv = $("#" + ColorSelector.currentSelectedButtonId + "_count");
        countDiv.text(cnt);

        var bigButtonCountDiv = $("#colorButton_count");
        bigButtonCountDiv.text(cnt);


    },
    closeSelected: function (btnDiv) {

        // if just added this button (ie last button)
        var colorBtnDiv = $(btnDiv);
        var colorBtnDivId = colorBtnDiv.attr("id");
        var colorBtnNum = colorBtnDivId.substring(colorBtnDivId.indexOf("_") + 1);
        if ((ColorSelector.totalBtns - 1).toString() === colorBtnNum) {
            var bgColor = colorBtnDiv.data("color");

            // check if color button already exists
            var existingColorSymbol = ColorSelector.getExistingColorBtn(bgColor, colorBtnDiv);
            if (existingColorSymbol !== "") {
                var colorBtnTableId = colorBtnDivId.replace("BtnDiv_", "BtnTable_");
                var colorBtnTable = $("#" + colorBtnTableId);
                colorBtnTable.hide();
            }
        }
    },
    getColorsSymbols: function () {
        var colorSymbols = [];
        for (var i = 0; i < ColorSelector.totalBtns; i++) {
            var colorBtnDiv = $("#colorBtnDiv_" + i.toString());
            var bgColor = colorBtnDiv.data("color");
            var btnColorHex = bgColor[0] === "#" ? bgColor.toLowerCase() : ColorConvert.rgbToHex(bgColor).toLowerCase();
            var symbolDiv = $("#colorBtnDiv_" + i.toString());
            var symbolHex = symbolDiv.data("symbol");
            colorSymbols[i] = { "color": btnColorHex, "symbol": symbolHex };
        }
        return colorSymbols;
    },
    isInside: function (x, y) {
        var colorSideNav = $("#colorSideNav");
        if (colorSideNav !== undefined) {
            var width = colorSideNav.width();
            var height = colorSideNav.height();
            var offset = colorSideNav.offset();
            if (x > offset.left && x < offset.left + width && y > offset.top && y < offset.top + height) {
                return true;
            }
        }
        var colorSelectorDiv = $("#colorSelectorDiv");
        if (colorSelectorDiv !== undefined) {
            var width = colorSelectorDiv.width();
            var height = colorSelectorDiv.height();
            var offset = colorSelectorDiv.offset();
            if (x > offset.left && x < offset.left + width && y > offset.top && y < offset.top + height) {
                return true;
            }
        }
        return false;
    },

    scrollToBottom: function () {
        var colorSelectorScrollDiv = $("#colorSelectorScrollDiv");
        colorSelectorScrollDiv.scrollTop(colorSelectorScrollDiv.prop("scrollHeight"));
    },
    updateColorCounts: function () {
        if (_pat !== undefined) {

            // all the static color buttons
            for (var i = 0; i < ColorSelector.colors.length; i++) {
                var count = _pat.getColorCount(ColorSelector.colors[i].color.toLowerCase());
                if (count !== undefined) {
                    var id = "staticColorBtn_" + i.toString();
                    var countDiv = $("#" + id + "_count");
                    countDiv.text(count);
                }
            }

            // all the user defined color buttons
            for (var i = 0; i < ColorSelector.totalBtns; i++) {
                var colorBtnDivId = "colorBtnDiv_" + i.toString();
                var colorBtnDiv = $("#" + colorBtnDivId);
                var bgColor = colorBtnDiv.data("color");
                var bgHex = bgColor[0] === "#" ? bgColor.toLowerCase() : ColorConvert.rgbToHex(bgColor).toLowerCase();
                var count = _pat.getColorCount(bgHex);
                if (count !== undefined) {
                    var countDiv = $("#colorBtn_" + i.toString() + "_count");
                    countDiv.text(count);
                    var colorUsed = true;
                    if (count > 0) {
                        colorBtnDiv.data("usedcolor", "yes");
                    }
                    else {
                        colorBtnDiv.data("usedcolor", "no");
                        colorUsed = false;
                    }
                    var btnId = colorBtnDivId.replace("Div", "");
                    if (ColorSelector.currentSelectedButtonId === btnId) {
                        ColorSelector.enableModifyButtons(true, colorUsed);
                    }
                }
            }
        }
    }
};