﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved

var buttonBar = {
    displayButtonBar: function (displayBtnBar) {
        var btnBar = $("#buttonbar");
        if (displayBtnBar) {
            btnBar.show();
        }
        else {
            btnBar.hide();
        }
        buttonBar.displayImportBar(!displayBtnBar);
    },
    displayImportBar: function (display) {
        var importBar = $("#importBar");
        importBar.scrollLeft(0);
        if (display) {
            importBar.show();
        }
        else {
            importBar.hide();
        }
    },
    displayNumOfColors: function (displayNumOfColors) {
        var colorSpinner = $("#colorSpinnerDiv");
        var numColorsLabel = $("#numColorsLabel");
        if (displayNumOfColors) {
            colorSpinner.show();
            numColorsLabel.show();
        }
        else {
            colorSpinner.hide();
            numColorsLabel.hide();
        }
    },
    setNumberOfColors: function (numOfColors) {
        var importNumOfColorsText = $("#importNumOfColorsText");
        importNumOfColorsText.text(numOfColors.toString());
    },
    getNumberOfColors: function () {
        var importNumOfColorsText = $("#colorSpinner");
        var num = parseInt(importNumOfColorsText.val(), 10);
        return num;
    },
    displayBackButton: function (display) {
        var backBtn = $("#importBackBtn");
        if (display) {
            backBtn.show();
        }
        else {
            backBtn.hide();
        }
    },
    displayPleaseWait: function (display) {

        var pleaseWait = $("#pleaseWait");
        var importNextBtn = $("#importNextBtn");
        importNextBtn.removeAttr('disabled');

        if (display) {
            importNextBtn.attr('disabled', 'disabled');
            pleaseWait.show();
        }
        else {
            pleaseWait.hide();
        }
    }
};