﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved

var stamps = {
    path20x20: "",
    path25x25: "25x25",
    path30x30: "30x30",
    stampsSize20x20: "stamps20x20",
    stampsSize25x25: "stamps25x25",
    stampsSize30x30: "stamps30x30",
    sqWidth: 3,
    sqHeight: 5,
    rows20x20: 4,
    cols20x20: 5,
    rows25x25: 4,
    cols25x25: 5,
    rows30x30: 4,
    cols30x30: 5,
    padding: 4,
    pat20x20: [],
    pat25x25: [],
    pat30x30: [],
    patCnt: 0,
    stampOnPat: null,
    firstTime20x20: true,
    firstTime25x25: true,
    firstTime30x30: true,
    diffHeight: 0,

    page: 1,

    canvasOffset: { "top": 0, "left": 0 },
    // current index into completePatList/freePatList
    // can only read one pattern at a time
    // use this to keep track of which pattern we just read
    stampIndex: -1,
    size: "",

    selectedStamp: -1,
    // complete list of all patterns available to purchase
    stamps20x20: { "totalFiles": 12, "files": [

        { "filename": "s01.stp" },
        { "filename": "s02.stp" },
        { "filename": "s03.stp" },
        { "filename": "s04.stp" },
        { "filename": "s05.stp" },
        { "filename": "s06.stp" },
        { "filename": "s07.stp" },
        { "filename": "s08.stp" },
        { "filename": "s09.stp" },
        { "filename": "s10.stp" },

        { "filename": "s11.stp" },
        { "filename": "s12.stp" },
        { "filename": "s13.stp" },
        { "filename": "s14.stp" },
        { "filename": "s15.stp" },
        { "filename": "s16.stp" },
        { "filename": "s17.stp" },
        { "filename": "s18.stp" },
        { "filename": "s19.stp" },
        { "filename": "s20.stp" },

        { "filename": "s21.stp" },
        { "filename": "s22.stp" },
        { "filename": "s23.stp" },
        { "filename": "s24.stp" },
        { "filename": "s25.stp" },
        { "filename": "s26.stp" },
        { "filename": "s27.stp" },
        { "filename": "s28.stp" },
        { "filename": "s29.stp" },
        { "filename": "s30.stp" },

        { "filename": "s31.stp" },
        { "filename": "s32.stp" },
        { "filename": "s33.stp" },
        { "filename": "s34.stp" },
        { "filename": "s35.stp" },
        { "filename": "s36.stp" },
        { "filename": "s37.stp" },
        { "filename": "s38.stp" },
        { "filename": "s39.stp" },
        { "filename": "s40.stp" },

        { "filename": "s41.stp" },
        { "filename": "s42.stp" },
        { "filename": "s43.stp" },
        { "filename": "s44.stp" },
        { "filename": "s45.stp" },
        { "filename": "s46.stp" },
        { "filename": "s47.stp" },
        { "filename": "s48.stp" },
        { "filename": "s49.stp" },
        { "filename": "s50.stp" },
       ]
    },
    stamps25x25: { "totalFiles": 12, "files": [
        { "filename": "s0025001.stp" },
        { "filename": "s0025002.stp" },
        { "filename": "s0025003.stp" },
        { "filename": "s0025004.stp" },
        { "filename": "s0025005.stp" },
        { "filename": "s0025006.stp" },
        { "filename": "s0025007.stp" },
        { "filename": "s0025008.stp" },
        { "filename": "s0025009.stp" },
        { "filename": "s0025010.stp" },

        { "filename": "s0025011.stp" },
        { "filename": "s0025012.stp" },
        { "filename": "s0025013.stp" },
        { "filename": "s0025014.stp" },
        { "filename": "s0025015.stp" },
        { "filename": "s0025016.stp" },
        { "filename": "s0025017.stp" },
        { "filename": "s0025018.stp" },
        { "filename": "s0025019.stp" },
        { "filename": "s0025020.stp" },

        { "filename": "s0025031.stp" },
        { "filename": "s0025032.stp" },
        { "filename": "s0025033.stp" },
        { "filename": "s0025034.stp" },
        { "filename": "s0025035.stp" },
        { "filename": "s0025036.stp" },
        { "filename": "s0025037.stp" },
        { "filename": "s0025038.stp" },
        { "filename": "s0025039.stp" },
        { "filename": "s0025040.stp" },

        { "filename": "s0025051.stp" },
        { "filename": "s0025052.stp" },
        { "filename": "s0025053.stp" },
        { "filename": "s0025054.stp" },

       ]
    },
    stamps30x30: { "totalFiles": 12, "files": [
        { "filename": "s0030001.stp" },
        { "filename": "s0030002.stp" },
        { "filename": "s0030003.stp" },
        { "filename": "s0030004.stp" },
        { "filename": "s0030005.stp" },
        { "filename": "s0030006.stp" },
        { "filename": "s0030007.stp" },
        { "filename": "s0030008.stp" },
        { "filename": "s0030009.stp" },
        { "filename": "s0030010.stp" },

        { "filename": "s0030011.stp" },
        { "filename": "s0030012.stp" },
        { "filename": "s0030013.stp" },
        { "filename": "s0030014.stp" },
        { "filename": "s0030015.stp" },
        { "filename": "s0030016.stp" },
        { "filename": "s0030017.stp" },
        { "filename": "s0030018.stp" },
        { "filename": "s0030019.stp" },
        { "filename": "s0030020.stp" },

        { "filename": "s0030021.stp" },
        { "filename": "s0030022.stp" },
        { "filename": "s0030023.stp" },
        { "filename": "s0030024.stp" },
        { "filename": "s0030025.stp" },
        { "filename": "s0030026.stp" },
        { "filename": "s0030027.stp" },
        { "filename": "s0030028.stp" },
        { "filename": "s0030029.stp" },
        { "filename": "s0030030.stp" },

        { "filename": "s0030031.stp" },
        { "filename": "s0030032.stp" },
        { "filename": "s0030033.stp" },
        { "filename": "s0030034.stp" },
        { "filename": "s0030035.stp" },
        { "filename": "s0030036.stp" },
        { "filename": "s0030037.stp" },
        { "filename": "s0030038.stp" },
        { "filename": "s0030039.stp" },
        { "filename": "s0030040.stp" },

        ]
    },

    getRows: function () {
        if (stamps.size == stamps.stampsSize20x20)
            return stamps.rows20x20;
        else if (stamps.size == stamps.stampsSize25x25)
            return stamps.rows25x25;
        return stamps.rows30x30;
    },
    setRows: function (rows) {
        if (stamps.size == stamps.stampsSize20x20)
            stamps.rows20x20 = rows;
        else if (stamps.size == stamps.stampsSize25x25)
            stamps.rows25x25 = rows;
        else
            stamps.rows30x30 = rows;
    },
    getCols: function () {
        if (stamps.size == stamps.stampsSize20x20)
            return stamps.cols20x20;
        else if (stamps.size == stamps.stampsSize25x25)
            return stamps.cols25x25;
        return stamps.cols30x30;
    },
    setCols: function (cols) {
        if (stamps.size == stamps.stampsSize20x20)
            stamps.cols20x20 = cols;
        else if (stamps.size == stamps.stampsSize25x25)
            stamps.cols25x25 = cols;
        else
            stamps.cols30x30 = cols;
    },
    getFirstTime: function () {
        if (stamps.size == stamps.stampsSize20x20)
            return stamps.firstTime20x20;
        else if (stamps.size == stamps.stampsSize25x25)
            return stamps.firstTime25x25;
        return stamps.firstTime30x30;
    },
    setFirstTime: function (firstTime) {
        if (stamps.size == stamps.stampsSize20x20)
            stamps.firstTime20x20 = firstTime;
        else if (stamps.size == stamps.stampsSize25x25)
            stamps.firstTime25x25 = firstTime;
        else
            stamps.firstTime30x30 = firstTime;
    },

    getPath: function () {
        if (stamps.size === stamps.stampsSize20x20)
            return stamps.path20x20;
        else if (stamps.size === stamps.stampsSize25x25)
            return stamps.path25x25 + "/";
        else
            return stamps.path30x30 + "/";
    },
    getStampWidth: function () {
        if (stamps.size === stamps.stampsSize20x20)
            return 20 * stamps.sqWidth;
        else if (stamps.size === stamps.stampsSize25x25)
            return 26 * stamps.sqWidth;
        else if (stamps.size === stamps.stampsSize30x30)
            return 30 * stamps.sqWidth;
    },

    getStampHeight: function () {
        if (stamps.size === stamps.stampsSize20x20)
            return 20 * stamps.sqHeight;
        else if (stamps.size === stamps.stampsSize25x25)
            return 26 * stamps.sqHeight;
        else if (stamps.size === stamps.stampsSize30x30)
            return 30 * stamps.sqHeight;
    },
    resetPageNumber: function () {

        var length = 0;
        if (stamps.size === stamps.stampsSize20x20) {
            length = stamps.pat20x20.length;
        }
        else if (stamps.size === stamps.stampsSize25x25) {
            length = stamps.pat25x25.length;
        }
        else {
            length = stamps.pat30x30.length;
        }
        while (stamps.page > 1 && stamps.page * stamps.getRows() * stamps.getCols() > length) {
            stamps.page = stamps.page - 1;
        }
    },
    setActive: function (btn) {
        $("#stamps20").removeClass("ui-btn-active");
        $("#stamps25").removeClass("ui-btn-active");
        $("#stamps30").removeClass("ui-btn-active");
        stamps.patCnt = 0;
        var tab = $(btn);
        tab.addClass("ui-btn-active");

        var id = tab.prop("id");
        if (id === "stamps20") {
            if (stamps.size !== stamps.stampsSize20x20) {
                stamps.setCanvasSize(stamps.stampsSize20x20);
                stamps.getStampFiles(stamps.size);
            }
        }
        else if (id === "stamps25") {
            if (stamps.size !== stamps.stampsSize25x25) {
                stamps.setCanvasSize(stamps.stampsSize25x25);
                stamps.getStampFiles(stamps.size);
            }
        }
        else if (id === "stamps30") {
            if (stamps.size !== stamps.stampsSize30x30) {
                stamps.setCanvasSize(stamps.stampsSize30x30);
                stamps.getStampFiles(stamps.size);
            }
        }
        stamps.displayNextPrevBtns();
    },

    // copy all patterns to application folder file:////data/data/com.SandCastleDesings.filetcrochet/files/
    getStampFiles: function (size) {
        stamps.size = size;
        if (stamps.getFirstTime()) {
            stamps.stampIndex = 0;
            // set to page 1
            stamps.page = 1;
            // start with first one, when it is done a call is made to get the next one myPat.getMyPatFile(1);
            stamps.getStampFile(0);
            stamps.setFirstTime(false);
        }
        else {
            stamps.page = 1;
            stamps.redisplayStamps();
        }
    },

    // get a pattern file from www/data folder that can be purchased
    getStampFile: function (i) {

        // for each file listed in the completPatList array
        if (i < stamps[stamps.size].files.length) {

            var path = stamps.getPath();

            // read the .cht file
            $.ajax({
                url: 'data/stamps/' + path + stamps[stamps.size].files[stamps.stampIndex].filename,
                type: "get",
                dataType: "text",

                success: function (data, textStatus, jqXHR) {

                    // read the title from the pattern
                    stamps.displayStamps(stamps.size, i, stamps[stamps.size].files[i].filename, data);
                    stamps.getNextStampFile();
                },

                // just continue if could not read this file
                error: function (jqXHR, textStatus, errorThrown) {
                    stamps.getNextStampFile();
                }
            });
        }
    },
    // get the next pattern from the list
    // if no more patterns to read then refresh the list
    getNextStampFile: function () {
        stamps.stampIndex++;

        // read next pattern
        if (stamps.stampIndex < stamps[stamps.size].files.length) {
            stamps.getStampFile(stamps.stampIndex);
        }
        else {
            stamps.displayNextPrevBtns();
        }
    },

    setCanvasSize: function (size) {

        stamps.size = size;
        // see pattern.css file
        var minWidth = 1.0 - 0.93;


        var deviceWidth = app.deviceWidth() - (minWidth * app.deviceWidth()) - 15;
        if (app.deviceWidth() > app.deviceHeight()) {
            deviceWidth -= 30;
        }
        var deviceHeight = app.deviceHeight() - 80;

        var navbar = $("#stampsNavbar");
        var navbarHeight = navbar.height();

        var headerHeight = $("#stampsHeader").height();
        var closeHeight = $("#closebutton").height();
        var stampsButtonbar = $("#stampsButtonbar").height();

        var stampWidth = stamps.getStampWidth();
        var stampHeight = stamps.getStampHeight();

        var cols = Math.floor(deviceWidth / (stampWidth + stamps.padding));
        if (cols < 1)
            cols = 1;
        stamps.setCols(cols);

        if (navbarHeight !== 0) {
            stamps.diffHeight = navbarHeight + headerHeight + closeHeight + (3 * stampsButtonbar);
        }

        var rows = Math.floor((deviceHeight - stamps.diffHeight) / (stampHeight + stamps.padding));
        if (rows < 1)
            rows = 1;
        stamps.setRows(rows);

        var w = (cols * stampWidth) + (cols * stamps.padding);
        var h = (rows * stampHeight) + (rows * stamps.padding);

        var canvas = $("#stampsCanvas");
        canvas.width(w);
        canvas.height(h);
        canvas[0].width = w;
        canvas[0].height = h;
    },

    displayStamps: function (size, idx, filename, content) {

        stamps.size = size;
        var canvas = $("#stampsCanvas");
        var cols = stamps.getCols()
        var row = cols === 0 ? 0 : parseInt(idx / cols);

        if (size === stamps.stampsSize20x20) {
            stamps.pat20x20[stamps.patCnt] = new Pattern(canvas);
            stamps.pat20x20[stamps.patCnt].readPattern(content);
        }
        else if (size === stamps.stampsSize25x25) {

            stamps.pat25x25[stamps.patCnt] = new Pattern(canvas);
            stamps.pat25x25[stamps.patCnt].readPattern(content);
        }
        else {

            stamps.pat30x30[stamps.patCnt] = new Pattern(canvas);
            stamps.pat30x30[stamps.patCnt].readPattern(content);
        }
        var stampsRows = stamps.getRows();
        var stampsCols = stamps.getCols();

        // if will fit on this page
        // if row for pattern  <  total rows that fit on a page * page number
        // and row for pattern >= total rows that fit on a page * previous page number
        if (row < stampsRows * stamps.page && row >= stampsRows * (stamps.page - 1)) {

            var col = stampsCols === 0 ? 0 : idx % stampsCols;
            var w = stamps.getStampWidth();
            var h = stamps.getStampHeight();
            var x = (col * w) + (col * stamps.padding);
            var y = (row * h) + (row * stamps.padding);
            if (size === stamps.stampsSize20x20) {
                stamps.pat20x20[stamps.patCnt].drawStamp(canvas, x, y, stamps.sqWidth, stamps.sqHeight);
            }
            else if (size === stamps.stampsSize25x25) {
                stamps.pat25x25[stamps.patCnt].drawStamp(canvas, x, y, stamps.sqWidth, stamps.sqHeight);
            }
            else {
                stamps.pat30x30[stamps.patCnt].drawStamp(canvas, x, y, stamps.sqWidth, stamps.sqHeight);
            }
        }
        stamps.patCnt++;
    },
    redisplayStamps: function () {
        var pats = stamps.pat20x20;
        var w = stamps.getStampWidth();
        var h = stamps.getStampHeight();
        var canvas = $("#stampsCanvas");
        var stampSizeWidth = (20 * stamps.sqWidth) + stamps.padding;
        var stampSizeHeight = (20 * stamps.sqHeight) + stamps.padding;
        if (stamps.size === stamps.stampsSize25x25) {
            pats = stamps.pat25x25;
            stampSizeWidth = (25 * stamps.sqWidth) + stamps.padding;
            stampSizeHeight = (25 * stamps.sqHeight) + stamps.padding;
        }
        else if (stamps.size === stamps.stampsSize30x30) {
            pats = stamps.pat30x30;
            stampSizeWidth = (30 * stamps.sqWidth) + stamps.padding;
            stampSizeHeight = (30 * stamps.sqHeight) + stamps.padding;
        }

        var cols = stamps.getCols();
        var rows = stamps.getRows();
        var x = 0;
        var y = 0;
        var r = 0;
        var c = 0;
        for (var i = 0; i < pats.length; i++) {
            var row = cols === 0 ? 0 : parseInt(i / cols);
            if (row < rows * stamps.page && row >= rows * (stamps.page - 1)) {
                x = c * stampSizeWidth;
                y = r * stampSizeHeight;
                c++;
                if (c >= cols) {
                    c = 0;
                    r++;

                }
                pats[i].drawStamp(canvas, x, y, stamps.sqWidth, stamps.sqHeight);

            }
        }

    },
    displayNextPrevBtns: function () {

        // if on first page
        if (stamps.page <= 1) {
            $("#previous").prop("disabled", true);
        }
        else {
            $("#previous").prop("disabled", false);
        }

        var length = 0;
        if (stamps.size === stamps.stampsSize20x20) {
            length = stamps.pat20x20.length;
        }
        else if (stamps.size === stamps.stampsSize25x25) {
            length = stamps.pat25x25.length;
        }
        else {
            length = stamps.pat30x30.length;
        }

        // no more stamps to display
        if (stamps.page * stamps.getRows() * stamps.getCols() < length) {
            $("#next").prop("disabled", false);
        }
        else {
            $("#next").prop("disabled", true);
        }
    },

    nextPrevPage: function (next) {
        var stampCanvas = $("#stampsCanvas");

        // clear the canvas
        var canvas = stampCanvas[0];
        var context = canvas.getContext('2d');
        context.clearRect(0, 0, canvas.width, canvas.height);

        // going to next page
        stamps.page = next ? stamps.page + 1 : stamps.page - 1;

        var rows = stamps.getRows();
        var cols = stamps.getCols();
        var startIdx = (stamps.page - 1) * rows * cols;
        var endIdx = stamps.page * rows * cols;
        for (var i = startIdx; i < endIdx; i++) {
            var row = parseInt(i / cols) - (rows * (stamps.page - 1));
            var col = i % cols;
            var w = stamps.getStampWidth();
            var h = stamps.getStampHeight();

            var x = (col * w) + (col * stamps.padding);
            var y = (row * h) + (row * stamps.padding);

            var length = 0;
            var pat;
            if (stamps.size === stamps.stampsSize20x20) {
                pat = stamps.pat20x20;
            }
            else if (stamps.size === stamps.stampsSize25x25) {
                pat = stamps.pat25x25;
            }
            else {
                pat = stamps.pat30x30;
            }
            if (i < pat.length) {
                pat[i].drawStamp(stampCanvas, x, y, stamps.sqWidth, stamps.sqHeight);
            }
            else {
                break;
            }
        }
        stamps.displayNextPrevBtns();
    },

    selected: function (x, y) {

        var stampsCanvas = $("#stampsCanvas");
        var offset = stampsCanvas.offset();
        x -= offset.left;
        y -= offset.top;
        var w = stamps.getStampWidth();
        var h = stamps.getStampHeight();
        var cols = stamps.getCols();
        var rows = stamps.getRows();
        var colSelected = Math.floor(x / (w + stamps.padding));
        var rowSelected = Math.floor(y / (h + stamps.padding));
        var selected = colSelected + (rowSelected * cols);
        selected += rows * cols * (stamps.page - 1);
        var length = 0;
        if (stamps.size === stamps.stampsSize20x20) {
            length = stamps.pat20x20.length;
        }
        else if (stamps.size === stamps.stampsSize25x25) {
            length = stamps.pat25x25.length;
        }
        else {
            length = stamps.pat30x30.length;
        }
        // if user selected on a stamp and not blank space
        if (selected < length) {
            stamps.selectedStamp = selected; // colSelected + (rowSelected * stamps.cols);
            history.back();
        }
    },

    // display stamp drag box on pattern
    displayStampOnPattern: function () {

        var length = 0;
        if (stamps.size === stamps.stampsSize20x20) {
            length = stamps.pat20x20.length;
        }
        else if (stamps.size === stamps.stampsSize25x25) {
            length = stamps.pat25x25.length;
        }
        else {
            length = stamps.pat30x30.length;
        }
        // creat a draggable stamp on top of the pattern
        if (stamps.selectedStamp >= 0 && stamps.selectedStamp < length) {
            var size = 20;
            if (stamps.size == stamps.stampsSize25x25) {
                size = 26;
            }
            else if (stamps.size == stamps.stampsSize30x30) {
                size = 30;
            }

            var thumbnail = $("#thumbnail");
            var top = _pat.getTopOffset();
            var left = _pat.getLeftOffset();
            var patternDiv = $("#patternPage");
            var offset = patternDiv.offset();
            stamps.canvasOffset.top = top + offset.top;
            stamps.canvasOffset.left = left + offset.left;
            thumbnail.css('top', stamps.canvasOffset.top.toString() + "px");
            thumbnail.css('left', stamps.canvasOffset.left.toString() + "px");

            var stamptbCanvas = $('<canvas id="stamptb"></canvas>');
            thumbnail.append(stamptbCanvas);

            var w = size * _pat.getSqrW() + 2;
            var h = size * _pat.getSqrH() + 2;
            stamptbCanvas.width(w);
            stamptbCanvas.height(h);

            var stbCanvas = stamptbCanvas[0];
            stbCanvas.width = w;
            stbCanvas.height = h;
            var context = stbCanvas.getContext('2d');
            context.fillStyle = 'white';
            context.strokeStyle = "black";
            context.fillRect(0, 0, w - 1, h - 1);

            var pats;
            if (stamps.size === stamps.stampsSize20x20) {
                pats = stamps.pat20x20;
            }
            else if (stamps.size === stamps.stampsSize25x25) {
                pats = stamps.pat25x25;
            }
            else {
                pats = stamps.pat30x30;
            }
            var pat = pats[stamps.selectedStamp];
            stamps.stampOnPat = new Pattern(stamptbCanvas);

            // set the fill color to the currently selected color
            stamps.stampOnPat.setfilledSqrColor(ColorSelector.drawColor);
            stamps.stampOnPat.readPattern(pat.getContent());
            stamps.stampOnPat.drawStamp(stamptbCanvas, 0, 0, _pat.getSqrW(), _pat.getSqrH());

            // draw blue bounding box
            context.fillStyle = "rgba(0, 0, 200, 0.5)";
            context.strokeStyle = "#1b7ec1";
            context.lineWidth = 3;

            context.rect(1, 1, w - 2, h - 2);
            context.stroke();
        }
    },
    rotateStampOnPattern: function () {

        var rows = stamps.stampOnPat.getCols();
        var cols = stamps.stampOnPat.getRows();
        var btns = stamps.stampOnPat.getBtns();
        var box = [];

        // rotate the box
        for (var j = 0; j < cols; j++) {
            box[j] = [];
            for (var i = 0; i < rows; i++) {
                box[j][i] = btns[rows - i - 1][j];
            }
        }

        var stamptbCanvas = $('#stamptb');
        var stbCanvas = stamptbCanvas[0];
        var context = stbCanvas.getContext('2d');
        var w = rows * _pat.getSqrH() + 2;
        context.fillStyle = 'white';
        context.strokeStyle = "black";
        context.fillRect(0, 0, w - 1, w - 1);

        stamps.stampOnPat.readBtns(box, rows, cols);

        stamps.stampOnPat.drawStamp(stamptbCanvas, 0, 0, _pat.getSqrW(), _pat.getSqrH());

        // draw blue bounding box
        context.fillStyle = "rgba(0, 0, 200, 0.5)";
        context.strokeStyle = "#1b7ec1";
        context.lineWidth = 3;

        context.strokeRect(1, 1, w - 2, w - 2);
    },
    // mouse left button up. place stamp in pattern
    insertStampOnPattern: function () {
        var thumbnailDiv = $("#thumbnail");
        var offset = thumbnailDiv.offset();
        var pat = stamps.stampOnPat;
        var btns = pat.getBtns();
        var rows = pat.getRows();
        var cols = pat.getCols();

        var patDivOffset = $("#patternPage").offset();
        var startRow = Math.floor((offset.top - patDivOffset.top - _pat.getTopOffset()) / _pat.getSqrH());
        var startCol = Math.floor((offset.left - patDivOffset.left - _pat.getLeftOffset()) / _pat.getSqrW());
        _pat.insertStamp(startRow, startCol, btns, rows, cols);

        stamps.removeStampOnPattern();
        _pat.drawGridPattern();
        editor.modified = true;
        app.enableIconbar(true);
    },

    // remove stamps drag box
    removeStampOnPattern: function () {
        // remove the stamp canavs
        $("#stamptb").remove();
        var thumbnailDiv = $("#thumbnail");
        thumbnailDiv.css('top', "0px");
        thumbnailDiv.css('left', "0px");
        stamps.selectedStamp = -1;
        stamps.stampOnPat = null;
    }
};
