﻿// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var import = {
    img: null,
    // pattern on pattern page top, left
    patOffset: { "top": 0, "left": 0 },

    displayImageOnPattern: function (image) {
        import.img = image;
        if (import.img != null) {
            var patDiv = $("#patternPage");
            var thumbnail = $("#thumbnail");
            var top = _pat.getTopOffset();
            var left = _pat.getLeftOffset();

            var offset = inserts.patOffset;
            inserts.canvasOffset.top = top + offset.top;
            inserts.canvasOffset.left = left + offset.left;
            thumbnail.css('top', inserts.canvasOffset.top.toString() + "px");
            thumbnail.css('left', inserts.canvasOffset.left.toString() + "px");

            var inserttbCanvas = $('<canvas id="inserttb"></canvas>');
            thumbnail.append(inserttbCanvas);

            var h = (inserts.pat.getRows() * _pat.getSqrW()) + 2;
            var w = (inserts.pat.getCols() * _pat.getSqrW()) + 2;
            inserttbCanvas.width(w);
            inserttbCanvas.height(h);

            var itbCanvas = inserttbCanvas[0];
            itbCanvas.width = w;
            itbCanvas.height = h;

            var context = itbCanvas.getContext('2d');
            context.fillStyle = 'white';
            context.strokeStyle = "black";
            context.fillRect(0, 0, w - 1, h - 1);

            inserts.insertOnPat = new Pattern(inserttbCanvas);
            inserts.insertOnPat.readPattern(inserts.pat.getContent());
            inserts.insertOnPat.drawInsert(inserttbCanvas, 0, 0, _pat.getSqrW(), _pat.getSqrH());

            // draw blue bounding box
            context.fillStyle = "rgba(0, 0, 200, 0.5)";
            context.strokeStyle = "#1b7ec1";
            context.lineWidth = 3;

            context.rect(1, 1, w - 2, h - 2);
            context.stroke();
        }
        inserts.cancel = false;
    }
};