// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var inserts = {
    insert: [
               { "info": { "folder": "animals", "title": "Animals", "totalFiles": 12, "files": [
                    { "filename": "bunny.ist", "title": "Bunny" },
                    { "filename": "camel.ist", "title": "Camel" },
                    { "filename": "camel2.ist", "title": "Camel 2" },
                    { "filename": "cat.ist", "title": "Cat" },
                    { "filename": "cat2.ist", "title": "Cat 2" },
                    { "filename": "deer.ist", "title": "Deer" },
                    { "filename": "dog.ist", "title": "Dog" },
                    { "filename": "dog2.ist", "title": "Dog 2" },
                    { "filename": "dog3.ist", "title": "Dog 3" },
                    { "filename": "dolphine.ist", "title": "Dolphine" },
                    { "filename": "elephant.ist", "title": "Elephant" },
                    { "filename": "elephant2.ist", "title": "Elephant 2" },
                    { "filename": "fish.ist", "title": "Fish" },
                    { "filename": "giraffe.ist", "title": "Giraffe" },
                    { "filename": "horse.ist", "title": "Horse" },
                    { "filename": "horse2.ist", "title": "Horse 2" },
                    { "filename": "horse3.ist", "title": "Horse 3" },
                    { "filename": "kangaroo.ist", "title": "Kangaroo" },
                    { "filename": "panda.ist", "title": "Panda" },
                    { "filename": "penguin.ist", "title": "Penguin" },
                    { "filename": "seahorse.ist", "title": "Seahorse" },
                    { "filename": "swan.ist", "title": "Swan" },
                    { "filename": "swordfish.ist", "title": "Swordfish" },
                    { "filename": "turtle.ist", "title": "Turtle" },
                    { "filename": "whale.ist", "title": "Whale"}]
               }
               },
                { "info": { "folder": "baby", "title": "Baby", "totalFiles": 12, "files": [
                    { "filename": "babybird.ist", "title": "Baby bird" },
                    { "filename": "babyblocks.ist", "title": "Baby blocks" },
                    { "filename": "babyboy.ist", "title": "Baby boy" },
                    { "filename": "babygirl.ist", "title": "Baby girl" },
                    { "filename": "babytee.ist", "title": "Baby tee" },
                    { "filename": "blocksandrattles.ist", "title": "Blocks and rattles" },
                    { "filename": "bottlesandbows.ist", "title": "Bottles and bows" },
                    { "filename": "buggieandbows.ist", "title": "Buggie and bows" },
                    { "filename": "diaperpins.ist", "title": "Diaper pins" },
                    { "filename": "diapersandpins.ist", "title": "Diapers and pins" },
                    { "filename": "pacifier.ist", "title": "Pacifier" },
                    { "filename": "rattle.ist", "title": "Rattle" },
                    { "filename": "rockinghorse.ist", "title": "Rocking horse" },
                    { "filename": "sipcup.ist", "title": "Sippy cup" },
                    { "filename": "teddybear.ist", "title": "Teddybear"}]
                }
                },
                { "info": { "folder": "birdsandbugs", "title": "Birds And Bugs", "totalFiles": 12, "files": [
                    { "filename": "ant.ist", "title": "Ant" },
                    { "filename": "bee.ist", "title": "Bee" },
                    { "filename": "bird1.ist", "title": "Bird 1" },
                    { "filename": "bird2.ist", "title": "Bird 2" },
                    { "filename": "bird3.ist", "title": "Bird 3" },
                    { "filename": "bird4.ist", "title": "Bird 4" },
                    { "filename": "bird5.ist", "title": "Bird 5" },
                    { "filename": "bird6.ist", "title": "Bird 6" },
                    { "filename": "bird7.ist", "title": "Bird 7" },
                    { "filename": "butterfly1.ist", "title": "Butterfly 1" },
                    { "filename": "butterfly2.ist", "title": "Butterfly 2" },
                    { "filename": "butterfly3.ist", "title": "Butterfly 3" },
                    { "filename": "butterfly4.ist", "title": "Butterfly 4" },
                    { "filename": "butterfly5.ist", "title": "Butterfly 5" },
                    { "filename": "butterfly6.ist", "title": "Butterfly 6" },
                    { "filename": "chick.ist", "title": "Chick" },
                    { "filename": "dragonfly.ist", "title": "Dragonfly" },
                    { "filename": "duck.ist", "title": "Duck" },
                    { "filename": "firefly.ist", "title": "Firefly" },
                    { "filename": "flyingbeetle.ist", "title": "Flying beetle" },
                    { "filename": "ladybug.ist", "title": "Ladybug" },
                    { "filename": "spider.ist", "title": "Spider"}]
                }
                },
                { "info": { "folder": "fantasy", "title": "Fantasy", "totalFiles": 12, "files": [
                     { "filename": "angel.ist", "title": "Angel" },
                     { "filename": "dragon.ist", "title": "Dragon" },
                     { "filename": "dragon2.ist", "title": "Dragon 2" },
                     { "filename": "unicorn.ist", "title": "Unicorn" },
                     { "filename": "wizardhat.ist", "title": "Wizard hat"}]
                }
                },
                { "info": { "folder": "flowers", "title": "Flowers", "totalFiles": 12, "files": [
                    { "filename": "flower1.ist", "title": "Flower 1" },
                    { "filename": "flower2.ist", "title": "Flower 2" },
                    { "filename": "flower3.ist", "title": "Flower 3" },
                    { "filename": "flower4.ist", "title": "Flower 4" },
                    { "filename": "flower5.ist", "title": "Flower 5" },
                    { "filename": "flower6.ist", "title": "Flower 6" },
                    { "filename": "flower7.ist", "title": "Flower 7" },
                    { "filename": "flower8.ist", "title": "Flower 8" },
                    { "filename": "flower9.ist", "title": "Flower 9" },
                    { "filename": "flowers10.ist", "title": "Flower 10" },
                    { "filename": "flowers11.ist", "title": "Flower 11" },
                    { "filename": "flowers12.ist", "title": "Flower 12" },
                    { "filename": "flowers13.ist", "title": "Flower 13" },
                    { "filename": "flowers14.ist", "title": "Flower 14" },
                    { "filename": "flowers15.ist", "title": "Flower 15" },
                    { "filename": "flowers16.ist", "title": "Flower 16" },
                    { "filename": "flowers17.ist", "title": "Flower 17" },
                    { "filename": "flowers18.ist", "title": "Flower 18" },
                    { "filename": "flowers19.ist", "title": "Flower 19" },
                    { "filename": "flowers20.ist", "title": "Flower 20" },
                    { "filename": "flowers21.ist", "title": "Flower 21" },
                    { "filename": "flowers22.ist", "title": "Flower 22" },
                    { "filename": "flowers23.ist", "title": "Flower 23" },
                    { "filename": "flowers24.ist", "title": "Flower 24" },
                    { "filename": "flowers25.ist", "title": "Flower 25" },
                    { "filename": "flowers26.ist", "title": "Flower 26" },
                    { "filename": "flowers27.ist", "title": "Flower 27" },
                    { "filename": "flowers28.ist", "title": "Flower 28" },
                    { "filename": "rose1.ist", "title": "Rose 1" },
                    { "filename": "rose2.ist", "title": "Rose 2" },
                    { "filename": "rose3.ist", "title": "Rose 3" },
                    { "filename": "rose4.ist", "title": "Rose 4" },
                    { "filename": "rose5.ist", "title": "Rose 5" },
                    { "filename": "rose6.ist", "title": "Rose 6" },
                    { "filename": "rose7.ist", "title": "Rose 7" },
                    { "filename": "rose8.ist", "title": "Rose 8" },
                    { "filename": "rose9.ist", "title": "Rose 9" },
                    { "filename": "roses10.ist", "title": "Rose 10" },
                    { "filename": "roses11.ist", "title": "Rose 11" },
                    { "filename": "roses12.ist", "title": "Rose 12" },
                    { "filename": "roses13.ist", "title": "Rose 13" },
                    { "filename": "roses14.ist", "title": "Rose 14" },
                    { "filename": "roses15.ist", "title": "Rose 15"}]
                }
                },
                { "info": { "folder": "hearts", "title": "Hearts", "totalFiles": 12, "files": [
                   { "filename": "hearts1.ist", "title": "Hearts 1" },
                   { "filename": "hearts2.ist", "title": "Hearts 2" },
                   { "filename": "hearts3.ist", "title": "Hearts 3" },
                   { "filename": "hearts4.ist", "title": "Hearts 4" },
                   { "filename": "hearts5.ist", "title": "Hearts 5" },
                   { "filename": "hearts6.ist", "title": "Hearts 6" },
                   { "filename": "hearts7.ist", "title": "Hearts 7" },
                   { "filename": "hearts8.ist", "title": "Hearts 8" },
                   { "filename": "hearts9.ist", "title": "Hearts 9" },
                   { "filename": "hearts10.ist", "title": "Hearts 10" },
                   { "filename": "hearts11.ist", "title": "Hearts 11"}]
                }
                },
                { "info": { "folder": "religious", "title": "Religious", "totalFiles": 12, "files": [
                    { "filename": "religious1.ist", "title": "Religious 1" },
                    { "filename": "religious2.ist", "title": "Religious 2" },
                    { "filename": "religious3.ist", "title": "Religious 3" },
                    { "filename": "religious4.ist", "title": "Religious 4" },
                    { "filename": "religious5.ist", "title": "Religious 5" },
                    { "filename": "religious6.ist", "title": "Religious 6" },
                    { "filename": "religious7.ist", "title": "Religious 7" },
                    { "filename": "religious8.ist", "title": "Religious 8"}]
                }
                },
                { "info": { "folder": "ribbonsandbows", "title": "Ribbons And Bows", "totalFiles": 12, "files": [
                   { "filename": "bow1.ist", "title": "Bow 1" },
                   { "filename": "bow2.ist", "title": "Bow 2" },
                   { "filename": "bow3.ist", "title": "Bow 3" },
                   { "filename": "bow4.ist", "title": "Bow 4" },
                   { "filename": "bow5.ist", "title": "Bow 5" },
                   { "filename": "bow6.ist", "title": "Bow 6" },
                   { "filename": "bow7.ist", "title": "Bow 7" },
                   { "filename": "bow8.ist", "title": "Bow 8" },
                   { "filename": "bow9.ist", "title": "Bow 9" },
                   { "filename": "bow10.ist", "title": "Bow 10" },
                   { "filename": "bow11.ist", "title": "Bow 11" },
                   { "filename": "ribbon1.ist", "title": "Ribbon 1" },
                   { "filename": "ribbon2.ist", "title": "Ribbon 2" },
                   { "filename": "ribbon3.ist", "title": "Ribbon 3" },
                   { "filename": "ribbon4.ist", "title": "Ribbon 4" },
                   { "filename": "ribbon5.ist", "title": "Ribbon 5" },
                   { "filename": "ribbon6.ist", "title": "Ribbon 6" },
                   { "filename": "ribbon7.ist", "title": "Ribbon 7" },
                   { "filename": "ribbon8.ist", "title": "Ribbon 8" },
                   { "filename": "ribbon9.ist", "title": "Ribbon 9" },
                   { "filename": "ribbon10.ist", "title": "Ribbon 10" },
                   { "filename": "ribbon11.ist", "title": "Ribbon 11"}]
                }
                },
                { "info": { "folder": "sports", "title": "Sports", "totalFiles": 12, "files": [
                   { "filename": "ballet.ist", "title": "Ballet" },
                   { "filename": "baseball.ist", "title": "Baseball" },
                   { "filename": "basketball.ist", "title": "Basketball" },
                   { "filename": "bike.ist", "title": "Bike" },
                   { "filename": "football.ist", "title": "Football" },
                   { "filename": "golf.ist", "title": "Golf" },
                   { "filename": "hockey.ist", "title": "Hockey" },
                   { "filename": "iceskate1.ist", "title": "Iceskate" },
                   { "filename": "rollerblade.ist", "title": "Rollerblade" },
                   { "filename": "soccer.ist", "title": "Soccer" },
                   { "filename": "tennis.ist", "title": "Tennis"}]
                }
                },
                { "info": { "folder": "wedding", "title": "Wedding", "totalFiles": 12, "files": [
                   { "filename": "bells.ist", "title": "Bells" },
                   { "filename": "bells2.ist", "title": "Bells 2" },
                   { "filename": "bouquet.ist", "title": "Bouquet" },
                   { "filename": "bride.ist", "title": "Bride" },
                   { "filename": "cake.ist", "title": "Cake" },
                   { "filename": "church.ist", "title": "Church" },
                   { "filename": "church2.ist", "title": "Church 2" },
                   { "filename": "doves.ist", "title": "Doves" },
                   { "filename": "groom.ist", "title": "Groom" },
                   { "filename": "keytomyheart.ist", "title": "Key to my heart" },
                   { "filename": "toastingglasses.ist", "title": "Toasting Glasses" },
                   { "filename": "weddingrings.ist", "title": "Wedding rings"}]
                }
                }
        ],
    pat: null,
    insertOnPat: null,

    // thumbnail on pattern page top, left
    canvasOffset: { "top": 0, "left": 0 },

    // pattern on pattern page top, left
    patOffset: { "top": 0, "left": 0 },

    // filename of selected insert xxx.ist
    selectedInsert: "",
    // current index into completePatList/freePatList
    // can only read one pattern at a time
    // use this to keep track of which pattern we just read
    insertIndex: -1,

    cancel: false,

    setSize: function () {
        var menu = $("#insertsMenu");
        var deviceHeight = app.deviceHeight();
        var newHeight = .40 * deviceHeight;
        menu.height(newHeight);

        var canvas = $("#insertsCanvas");
        var newHeight = .20 * deviceHeight;
        canvas.height(newHeight);
    },

    createList: function () {
        var menu = $("#insertsMenu");
       

        var tree = "<div style='margin: 0; padding: 0' data-role='collapsible-set'  >";
        inserts.insert.forEach(function (insert, index) {
            tree += "<div style='margin: 0; padding: 0' data-role='collapsible' data-inset='false' >" +
                               "<h3   class='collapse_header'>" + insert.info.title + "</h3>" +
                                  "<div style='margin: 0; padding: 0' data-role='fieldcontain' style='height:200px; overflow-y:scroll;'>" +
                                       "<fieldset style='margin: 0; padding: 0'  data-role='controlgroup' >";
            tree += "<div style='margin: 0; padding: 0' >";
            var columnCnt = 0;
            var half = Math.floor(insert.info.files.length / 2);
            insert.info.files.forEach(function (file, i) {

                var name = file.filename.substring(0, file.filename.indexOf("."));
                tree += "<input type ='radio' style='width:100%' class='inserts_radio' name='" + insert.info.title + "_group'  id='" + name + "_radio'  data-index='" + index + "' data-file='" + name + "' onclick='inserts.displayInsert(this)' />" +
                                          "<label for='" + name + "_radio'>" + file.title + "</label>";
                columnCnt++;
                
            });
            tree += "</div>";
            tree += "</fieldset>" +
                       "</div>" +
                      "</div>";

        });
        tree += "</div>";
        menu.append(tree);
        $("#insertsInsertButton").addClass('ui-disabled');
    },

    setSelected: function () {
        var radios = $(".inserts_radio");
        for (var i = 0; i < radios.length; i++) {
            var btn = $(radios[i]);
            var isChecked = btn.prop("checked");
            if (isChecked) {
                inserts.selectedInsert = btn.data("file") + ".ist";
                break;
            }
        }
    },

    displayInsert: function (btn) {
        var filename = $(btn).data("file") + ".ist";
        var index = $(btn).data("index");
        var path = inserts.insert[index].info.folder;
        inserts.getInsertFile(path, filename);
        var radio = $(".inserts_radio");
        radio.prop("checked", false);
        $(btn).prop('checked', true);
        radio.checkboxradio().checkboxradio("refresh");
        $('div[data-role=collapsible]').collapsible();
        $("#insertsInsertButton").removeClass('ui-disabled');
        inserts.selectedInsert = filename;
    },

    // get a pattern file from www/data folder that can be purchased
    getInsertFile: function (path, filename) {
        // read the .cht file
        $.ajax({
            url: 'data/inserts/' + path + '/' + filename,
            type: "get",
            dataType: "text",

            success: function (data, textStatus, jqXHR) {
                // read the title from the pattern
                var canvas = $("#insertsCanvas");
                inserts.pat = new Pattern(canvas);
                inserts.pat.readPattern(data);
                inserts.pat.drawInsert(canvas, 0, 0, 0, 0);
            },

            // just continue if could not read this file
            error: function (jqXHR, textStatus, errorThrown) {
                alert('Sorry could not find file ' + filename);
            }
        });
    },

    // user selected Place insert on pattern button
    // display insert drag box on pattern
    displayInsertOnPattern: function () {

        if (inserts.pat != null && !inserts.cancel) {
            var patDiv = $("#patternPage");
            var thumbnail = $("#thumbnail");
            var top = _pat.getTopOffset();
            var left = _pat.getLeftOffset();

            var offset = inserts.patOffset;
            inserts.canvasOffset.top = top + offset.top;
            inserts.canvasOffset.left = left + offset.left;
            thumbnail.css('top', inserts.canvasOffset.top.toString() + "px");
            thumbnail.css('left', inserts.canvasOffset.left.toString() + "px");

            var inserttbCanvas = $('<canvas id="inserttb"></canvas>');
            thumbnail.append(inserttbCanvas);

            var h = (inserts.pat.getRows() * _pat.getSqrH()) + 2;
            var w = (inserts.pat.getCols() * _pat.getSqrW()) + 2;
            inserttbCanvas.width(w);
            inserttbCanvas.height(h);

            var itbCanvas = inserttbCanvas[0];
            itbCanvas.width = w;
            itbCanvas.height = h;

            var context = itbCanvas.getContext('2d');
            context.fillStyle = 'white';
            context.strokeStyle = "black";
            context.fillRect(0, 0, w - 1, h - 1);

            inserts.insertOnPat = new Pattern(inserttbCanvas);
            inserts.insertOnPat.setfilledSqrColor(ColorSelector.drawColor);
            inserts.insertOnPat.readPattern(inserts.pat.getContent());
            inserts.insertOnPat.drawInsert(inserttbCanvas, 0, 0, _pat.getSqrW(), _pat.getSqrH());

            // draw blue bounding box
            context.fillStyle = "rgba(0, 0, 200, 0.5)";
            context.strokeStyle = "#1b7ec1";
            context.lineWidth = 3;

            context.rect(1, 1, w - 2, h - 2);
            context.stroke();
        }
        inserts.cancel = false;
    },

    rotateInsertOnPattern: function () {
        if (inserts.insertOnPat !== null) {
            var insertRows = inserts.insertOnPat.getRows();
            var insertCols = inserts.insertOnPat.getCols();
            var rows = inserts.insertOnPat.getCols();
            var cols = inserts.insertOnPat.getRows();
            var btns = inserts.insertOnPat.getBtns();
            var box = [];

            // rotate the box
            for (var j = 0; j < insertCols; j++) {
                box[j] = [];
                for (var i = 0; i < insertRows; i++) {
                    box[j][i] = btns[insertRows - i - 1][j];
                }
            }


            inserts.insertOnPat.readBtns(box, rows, cols);

            // change the width to height and height to width
            var h = (inserts.insertOnPat.getRows() * _pat.getSqrH()) + 2;
            var w = (inserts.insertOnPat.getCols() * _pat.getSqrW()) + 2;

            var inserttbCanvas = $("#inserttb");
            inserttbCanvas.width(w);
            inserttbCanvas.height(h);

            var itbCanvas = inserttbCanvas[0];
            itbCanvas.width = w;
            itbCanvas.height = h;

            var context = itbCanvas.getContext('2d');
            context.fillStyle = 'white';
            context.strokeStyle = "black";
            context.fillRect(0, 0, w - 1, h - 1);

            inserts.insertOnPat.drawInsert(inserttbCanvas, 0, 0, _pat.getSqrW(), _pat.getSqrH());

            // draw blue bounding box

            context.fillStyle = "rgba(0, 0, 200, 0.5)";
            context.strokeStyle = "#1b7ec1";
            context.lineWidth = 3;

            context.strokeRect(1, 1, w - 2, h - 2);

        }
    },

    // user finished dragging the insert to location they wanted
    insertInsertOnPattern: function () {
        var thumbnailDiv = $("#thumbnail");
        var offset = thumbnailDiv.offset();
        var pat = inserts.insertOnPat;
        var btns = pat.getBtns();
        var rows = pat.getRows();
        var cols = pat.getCols();

        var patDivOffset = $("#patternPage").offset();
        var startRow = Math.floor((offset.top - patDivOffset.top - _pat.getTopOffset()) / _pat.getSqrH());
        var startCol = Math.floor((offset.left - patDivOffset.left - _pat.getLeftOffset()) / _pat.getSqrW());
        _pat.insertStamp(startRow, startCol, btns, rows, cols);

        // remove the insert canavs
        inserts.removeInsertOnPattern();
        _pat.drawGridPattern();
        editor.modified = true;
        app.enableIconbar(true);
    },

    // remove inserts drag box
    removeInsertOnPattern: function () {
        // remove the insert canavs
        $("#inserttb").remove();
        var thumbnailDiv = $("#thumbnail");
        thumbnailDiv.css('top', "0px");
        thumbnailDiv.css('left', "0px");
        inserts.selectedInsert = "";
        inserts.insertOnPat = null;
    }
    
};
