// Bead Loom Pattern Creator Mobile
// Copyright 2017 Sand Castle Designs.Inc
// All Rights Reserved
var tempFile = {

    content: [],
    canvas: [],
    current: -1,

    init: function () {
        tempFile.content = [];
        tempFile.canvas = [];
        tempFile.current = -1;
    },
    save: function () {

        tempFile.current++;
        tempFile.content[tempFile.current] = _pat.createPatternContent();
        var patCanvas = $("#patCanvas");
        var w = patCanvas.width();
        var h = patCanvas.height();
        tempFile.canvas[tempFile.current] = { "width": w, "height": h };
        var i = tempFile.current + 1;
        tempFile.content.splice(i, tempFile.content.length);
        tempFile.canvas.splice(i, tempFile.content.length);
    },
    getUndoContent: function () {
        if (tempFile.current - 1 >= 0) {
            tempFile.current--;
            if (tempFile.current == 0) {
                $("#undo").attr('disabled', 'disabled');
            }
            return tempFile.content[tempFile.current];
        }
        return "";
    },

    getRedoContent: function () {
        if (tempFile.current + 1 < tempFile.content.length) {
            tempFile.current++;
            if (tempFile.current == tempFile.content.length - 1) {
                $("#redo").attr('disabled', 'disabled');
            }
            return tempFile.content[tempFile.current];
        }
        return "";
    },

    getCanvasSize: function () {
        if (tempFile.current >= 0 && tempFile.current < tempFile.canvas.length) {
            return tempFile.canvas[tempFile.current];
        }
        else {
            return "";
        }
    }
};
